entusiasticsQuizGame = {};
entusiasticsQuizGame.questions_answered = 0;
entusiasticsQuizGame.questions_answered_texts = [];
entusiasticsQuizGame.choices_ids = [];

entusiasticsQuizGame.goon = function(quizID, url) {
	
	// make sure there is answer selected
	var qType = jQuery('#entusiastics-question-form-' + quizID + ' input[name=question_type]').val();	
	var chkClass = 'entusiastics-quiz-' + qType;
	jQuery('#entusiastics-quiz-action-' + quizID).attr('disabled', true);
	
	// is any checked?
	var anyChecked = false;
	jQuery('#entusiastics-question-form-' + quizID + ' .' + chkClass).each(function(){

		if(this.checked) {
			let profile_id = jQuery(this).attr('data-profile');
			jQuery('#profile-id-selected').val(profile_id);
			let choice_id = jQuery(this).val();
			jQuery('#choice-id-selected').val(choice_id);
			anyChecked = true;
		} 	

	});
	
	if(!anyChecked && (qType != 'text')) {
		alert(jQuery('#confirm_question_message').val());
		jQuery('#entusiastics-quiz-action-' + quizID).removeAttr('disabled');
		jQuery('#profile-id-selected').val();
		return false;
	}

	if(qType == 'text' && jQuery('#entusiastics-quiz-form-' + quizID + ' textarea[name=answer]').val() == '') {
		jQuery('#entusiastics-quiz-action-' + quizID).removeAttr('disabled');
		jQuery('#profile-id-selected').val();
		return false;
	}

	jQuery('#entusiastics-quiz-wrap-'+quizID).fadeOut();
	jQuery('#entusiastic-summary').fadeOut();
	var choice_id = jQuery('#choice-id-selected').val();
	this.choices_ids.push(choice_id);

	// submit the answer by ajax
	data = jQuery('#entusiastics-question-form-'+quizID).serialize();
	data += '&action=entusiastics_quiz_game_ajax';
	data += '&entusiastic_game_quiz_action=answer';
	this.questions_answered++;
	data += '&choices_ids=' + this.choices_ids;
	data += '&total_questions=' + this.questions_answered;

	var question_text = jQuery('#entusiastics-question-form-' + quizID + ' input[name=answer]').attr('data-title');
	this.questions_answered_texts.push(question_text);

	setTimeout(function(){
		jQuery('#entusiasticsLoading').fadeIn();
	}, 500);

	setTimeout(function(){
		postData(quizID, url, data);
	}, 1000);
}

entusiasticsQuizGame.initializeQuestion = function(quizID) {

	// Document Ready
	jQuery(document).ready(function() {

		jQuery('html').css('height', '100%');
		jQuery('html').css('min-height', '100%');
		
		jQuery('body').css('height', '100%');
		jQuery('body').css('min-height', '100%');
		jQuery('body').css('overflow', 'auto');

		jQuery('#site-content').css('height', '100%');
		jQuery('#site-content').css('min-height', '100%');
		jQuery('#site-content').css('overflow', 'inherit');
		
		jQuery('.main-container').css('height', '100%');
		jQuery('.main-container').css('min-height', '100%');

		jQuery('.post').css('height', '100%');
		jQuery('.post').css('min-height', '100%');

		jQuery('.post-inner').css('height', '100%');
		jQuery('.post-inner').css('min-height', '100%');

		var innerHeight = jQuery('.entusiastic-question-header-inner').height();
		jQuery('.entusiastic-question-header').css('max-height', (innerHeight + 50) + 'px');

		var current_padding_top = jQuery('.entusiastic-question-container').css('padding-top');
		jQuery('.entusiastic-question-container').css('padding-top', (current_padding_top + innerHeight) + 'px');

		if(!jQuery('.entusiastics-result-container').length) {

			let quiz_title = jQuery('.entusiastic-question-title-text').text().trim();
			let section_name = jQuery('.entusiastics-question p').text() != '' ? jQuery('.entusiastics-question p').text() : '';
			let last_question = jQuery('#last_question').val();
			let last_choice = jQuery('#last_answer').val();
			let last_connotation = jQuery('#last_connotation').val();
			let last_profile = jQuery('#last_profile').val();

			if(section_name != '') {
				section_name = section_name.trim();
			}

			if(last_connotation == '1') {
				last_connotation = 'Indicadores de Alta calidad';
			}

			if(last_connotation == '0') {
				last_connotation = 'Indicadores de Baja calidad';
			}

			window.dataLayer.push({
				'event': 'play',
				'nombre quiz': quiz_title,
				'pagina_actual': section_name,
				'número_pregunta': parseInt(entusiasticsQuizGame.questions_answered + 1),
				'pagina_anterior': last_question,
				'valor_elegido': last_choice,
				'indicador': last_connotation,
				'perfil': last_profile
			});

		}

		var acc = document.getElementsByClassName("accordion");
		var i;

		for (i = 0; i < acc.length; i++) {

			acc[i].addEventListener("click", function() {

				this.classList.toggle("active");

				var panel = this.nextElementSibling;

				if (panel.style.maxHeight) {
					panel.style.maxHeight = null;
				} else {
					panel.style.maxHeight = panel.scrollHeight + "px";
				}

			});

		}

		if(jQuery('#player').length > 0) {

			jQuery.getScript("https://www.youtube.com/iframe_api", function() {

				var video_url = jQuery('#video_url').data('url');

				loadVideo(video_url);
			});

		}

	});

	jQuery('.accordion-button').on('click', function(){

		jQuery('.summary-open-button').toggleClass('active');

		var panel = jQuery(this).parent().parent().parent().find('.accordion-panel');

		if (panel.css('max-height') != '0px') {
			jQuery('.accordion-button').removeClass("open");
			panel.css('max-height', '0px');
		} else {

			jQuery('.accordion-button').addClass("open");

			if ((navigator.userAgent.toLowerCase().indexOf("ipad") > -1) || (navigator.userAgent.toLowerCase().indexOf("iphone") > -1) || (navigator.userAgent.toLowerCase().indexOf("ipod") > -1)) {
				panel.css("max-height", (panel.prop('scrollHeight') * 3) + 'px');
			} else {
				panel.css("max-height", panel.prop('scrollHeight') + 'px');
			};

		}

		return false;
	});


	jQuery('#entusiastics-close-quiz-button').on('click', function(){
		jQuery('#entusiastics-info-modal').fadeIn();
	});

	jQuery('#entusiastics-modal-close-button').on('click', function(){

		jQuery('#entusiastics-info-modal').fadeOut();
		
		window.location.href = translated_strings.shortcode_url;
	});

	jQuery('#entusiastics-modal-continue-button').on('click', function(){
		jQuery('#entusiastics-info-modal').fadeOut();
	});

	jQuery(".entusiastics-quiz-frontend").click(function() {

		if(this.type == 'radio') {

			jQuery(".entusiastics-quiz-label").removeClass('active');
			jQuery(this).parent().toggleClass('active');
		}

		if(jQuery('#entusiastics-quiz-action-' + quizID).css('visibility') == 'visible') {
			jQuery([document.documentElement, document.body]).animate({
				scrollTop: jQuery('#entusiastics-quiz-action-' + quizID).offset().top
			}, 500);
		}

		if(this.type == 'radio' || this.type == 'checkbox') {		
			// enable button			
			jQuery('#entusiastics-quiz-action-' + quizID).removeAttr('disabled');
		}

	});

	jQuery(".entusiastics-quiz-frontend").on('change', function() {		
		
		if(this.type == 'checkbox') {

			if(this.checked) {

				jQuery('#entusiastics-quiz-action-' + quizID).removeAttr('disabled');
				jQuery('#entusiastics-quiz-info-checkbox-text').fadeOut();

			} else {

				var anyChecked = false;
				jQuery('#entusiastics-question-form-' + quizID + ' .entusiastics-quiz-' + this.type).each(function(){
					if(this.checked) {
						let profile_id = jQuery(this).attr('data-profile');
						jQuery('#profile-id-selected').val(profile_id);
						anyChecked = true;
					} 	
				});

				if(!anyChecked) {
					jQuery('#entusiastics-quiz-action-' + quizID).attr('disabled', 'disabled');
					jQuery('#entusiastics-quiz-info-checkbox-text').fadeIn();
				}
			}			
			
		}
	});
	
	jQuery(".entusiastics-quiz-frontend").on('keyup', function() {

		if(this.type == 'textarea') {

			if(jQuery(this).val() == '') {

				jQuery('#entusiastics-quiz-action-' + quizID).attr('disabled', 'disabled');

			} else {

				jQuery('#entusiastics-quiz-action-' + quizID).removeAttr('disabled');
			}
		}

	});

	function loadVideo(video_url) {

		window.YT.ready(function() {

			new window.YT.Player("player", {
				height: '470',
				width: '838',
				playerVars : {
					'autoplay' : 0,
					'rel' : 0,
					'showinfo' : 0,
					'egm' : 0,
					'showsearch' : 0,
					'controls' : 1,
					'modestbranding' : 1,
				},
				videoId: video_url,
				events: {
					'onStateChange': onPlayerStateChange
				}
			});
			
		});

		function onPlayerReady(event) {
			event.target.playVideo();
		}

		function onPlayerStateChange(event) {
			var videoStatuses = Object.entries(window.YT.PlayerState)
			if (event.data == 0) {
				jQuery('#entusiastics-choices-wrapper').fadeIn();
			}
		}

		function stopVideo() {
			player.stopVideo();
		}
	}

}

entusiasticsQuizGame.finalizeQuiz = function(quizID, sessionID, url) {

	let data = '&action=entusiastics_finalize_quizz';
	data += '&entusiastics_finalize_quizz=finalize';
	data += '&quiz_id='+quizID;
	data += '&last_profile='+ jQuery('#last_profile').val();
	data += '&last_question='+ jQuery('#last_question').val();
	data += '&last_connotation='+ jQuery('#last_connotation').val();
	data += '&session_id='+sessionID;

	jQuery('#entusiastics-quizzes-grid-container').fadeOut().remove();
	jQuery('#entusiastics-main-quiz-div-'+quizID).find('.entusiastics-quizz-wrapper').fadeOut();
	jQuery('#entusiasticsLoading').fadeIn();

	setTimeout(function(){
		postData(quizID, url, data);
	}, 1000);
}

entusiasticsQuizGame.startQuiz = function(quizID, url) {

	let data = jQuery('#entusiastics-quiz-form-'+quizID).serialize();
	data += '&action=entusiastics_quiz_game_ajax';
	data += '&entusiastic_game_quiz_action=start';

	jQuery('#entusiastics-quizzes-grid-container').fadeOut().remove();
	jQuery('#entusiastics-main-quiz-div-'+quizID).find('.entusiastics-quizz-wrapper').fadeOut();
	jQuery('#entusiasticsLoading').fadeIn();

	entusiasticsQuizGame.questions_answered = 0;
	entusiasticsQuizGame.questions_answered_texts = [];
	entusiasticsQuizGame.choices_ids = [];

	setTimeout(function(){
		postData(quizID, url, data);
	}, 1000);
}

function postData(quizID, url, data) {

	jQuery.post(url, data, function(msg) {

		parts = msg.split("|ENTUSIASTICSQUIZGAME|");	  

		jQuery('#entusiastics-quiz-action-' + quizID).removeAttr('disabled');

		// redirect?
		if(parts[1].indexOf('[ENTUSIASTICS_QUIZ_GAME_REDIRECT]') != -1) {

			jQuery('#entusiasticsLoading').hide();

			var sparts = parts[1].split('[ENTUSIASTICS_QUIZ_GAME_REDIRECT]');
			window.location=sparts[1];
		}
		else {
			jQuery('#entusiasticsLoading').hide();
		  	// load next question or the final screen
		  	jQuery('#entusiastics-main-quiz-div-'+quizID).html(parts[1]);	

			// hide/show "go ahead" button depending on comment in the HTML code
			if(parts[1].indexOf('<!--hide_go_ahead-->') != -1) jQuery('#entusiastics-quiz-action-' + quizID).hide();
			else jQuery('#entusiastics-quiz-action-' + quizID).show();  	  

			entusiasticsQuizGame.initializeQuestion(quizID);
		}

		jQuery('#entusiasticsLoading').hide();
	});
}

jQuery(function($){

	// Document Ready
	jQuery(document).ready(function() {

		jQuery('#entusiastics-close-quiz-button').on('click', function(){
			jQuery('#entusiastics-info-modal').fadeIn();
		});

		if(jQuery('#entusiastics-title-block').length) {
			var padding_top = jQuery('#entusiastics-title-block').height();
			jQuery('.entusiastics-quiz__body-block').css('padding-top', padding_top);
		}

		var acc = document.getElementsByClassName("accordion");
		var i;

		for (i = 0; i < acc.length; i++) {

			acc[i].addEventListener("click", function(e) {

				e.preventDefault();

				this.classList.toggle("active");

				var panel = this.nextElementSibling;

				if (panel.style.maxHeight) {
					panel.style.maxHeight = null;
				} else {
					panel.style.maxHeight = panel.scrollHeight + "px";
				}

			});

		}
	});
});